# IAtari

Genetic algorithm generating AI capable to play Atari2600 games.

## Getting Started

These instructions will get you a copy of the project up and running on your local machine for development or training purposes.

### Prerequisites

In order to use this algorithm you need a compiler that support c++ 14 and the boost library (`apt-get install libboost-all-dev`).

### Installing

Once this git repository is cloned, you need to set the environment variable LD_LIBRARY_PATH.
Writing this line in your .bashrc is a good way to achieve it : `export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/my/path/to/ale/directory`

Compile the algorithm by using `make` in the src subfolder.

## Training agents

Once you have set the value `algoGen` to true in the config file, type `./atari -m` in a terminal to launch the master. Type `./atari -s` in other terminals to launch slaves.

### Launcher

You can also use the launcher (GUI) to train your agents. It handles exactly the same parameters than the configuration file. As previously, launch the master before slaves.

## Exhib agents

Set `algoGen` to false and `displayScreen` to true in the config file and start the algorithm without arguments.

## Statistics scripts

There are two scripts that can provide statistics. `plot_register.py` will compute how registers and operators are used by an agent. `plot_agents.py` will compute the evolution of the score of an agent.
 
## Documentation

The documentation is available as a website in the subfolder doc/html.

## Build With

* This algorithm use the Arcade Learning Environment : [ALE repository](https://github.com/mgbellemare/Arcade-Learning-Environment)
* The documentation is built with Doxygen : [Doxygen website](http://www.doxygen.nl)

## License

Some parts of this algorithm come from Leela Zero Software which is licensed under [GNU License](https://www.gnu.org/licenses/gpl.txt).
The Threadpool.h file is licensed under [zlib license](https://www.zlib.net/zlib_license.html) which is actually fully compatible with the GNU license.

Consequently, the whole algorithm use the GNU license.

## Authors

* Tutor : Pascal GARCIA
* Hugo CHAUGIER
* Antonin GONTIER
* Corentin OLLIVIER
* Guillaume SONNET
