#include "loginpopup.h"

#include <QGridLayout>
#include <QPushButton>

LoginPopup::LoginPopup() : QDialog(){

    QGridLayout *layout = new QGridLayout(this);
    username = new LabelledWidget<QLineEdit>("Username : ");
    password = new LabelledWidget<QLineEdit>("Password :");

    password->getChild()->setEchoMode(QLineEdit::Password);

    buttons = new QDialogButtonBox(this);
    buttons->addButton(QDialogButtonBox::Ok);
    buttons->addButton(QDialogButtonBox::Cancel);
    buttons->button(QDialogButtonBox::Ok)->setText("Login");
    buttons->button(QDialogButtonBox::Cancel)->setText("Abort");

    QObject::connect(
        buttons->button(QDialogButtonBox::Cancel),
        SIGNAL(clicked()),
        this,
        SLOT(close())
    );

    QObject::connect(
        buttons->button(QDialogButtonBox::Ok),
        SIGNAL(clicked()),
        this,
        SLOT(slotLogin())
    );

    layout->addWidget(username->getWidget(),0,0);
    layout->addWidget(password->getWidget(),0,1);
    layout->addWidget(buttons,2,0,1,2);

    setLayout(layout);

}

void LoginPopup::slotLogin(){

    emit login(
        username->getChild()->text(),
        password->getChild()->text()
    );
    close();
}