#ifndef MASTERTAB_H
#define MASTERTAB_H


#include <QWidget>
#include <QHBoxLayout>
#include <QSpinBox>
#include <QDoubleSpinBox>
#include <QComboBox>
#include <QCheckBox>
#include <QPushButton>

#include "mainwindow.h"
#include "labelledwidget.h"

class MasterTab : public QWidget{
    Q_OBJECT
    MainWindow *window;
    QHBoxLayout *layout;
    LabelledWidget<QComboBox>
        *rom_path,
        *colour_palette;
    LabelledWidget<QCheckBox>
        *display_screen,
        *enable_sound,
        *fresh_pop;
    
    LabelledWidget<QDoubleSpinBox>
    //Floats
        *repeat_action_prob,
        *mut_rate,
        *cross_rate;
    LabelledWidget<QSpinBox> 
    //Integers
        *n_eval_p,
        *n_eval_s,
        *tourn_size,
        *pop_size,
        *nb_iter;
    QPushButton *start;


public:


    MasterTab(MainWindow *window);
private:
    void loadCfg();
    void saveCfg();

public slots:
private slots:
    void launchMaster();

};

#endif