#include "slavestab.h"

#include <sstream> //Pour la creation de la commande
#include <unistd.h> //Pour avoir le nom de la machine
#include <fstream> //Lecture du fichier de machines

#include "QPushButton"
#include "QLineEdit"

#include "loginpopup.h"

#define MACHINE_LIST_PATH "machines.txt"


SlavesTab::SlavesTab(MainWindow *window) : QWidget()
{
    this->window = window;
    layout = new QVBoxLayout;
    groupboxes = new QHBoxLayout;

    //Lecture du fichier de liste de machines
    ifstream machine_file(MACHINE_LIST_PATH);

    string line; //Stocke la ligne courante
	
	//Lecture du fichier de machines
    while(getline(machine_file,line)){
        if(!line.size()) continue; //Passe les lignes vides
        //Creation de la groupbox
        PCGroupBox *pgb = new PCGroupBox(line);
		//Ajout aux groupboxes de la page slave
        groupboxes->addWidget(pgb);
    }




    layout->addLayout(groupboxes);

	QHBoxLayout *other_options = new QHBoxLayout;

    char hostname[256];
    gethostname(hostname,256);

	host_address = new LabelledWidget<QLineEdit>("Host Address", new QLineEdit(hostname));
    
    delay_spinner = new LabelledWidget<QSpinBox>("Delay");
    delay_spinner->getChild()->setMinimum(0);
    delay_spinner->getChild()->setMaximum(24);

	time_slave = new LabelledWidget<QSpinBox>("Time for a slave (min)");
    time_slave->getChild()->setMinimum(0);
    time_slave->getChild()->setMaximum(30);

    slaves_by_computer = new LabelledWidget<QSpinBox>("Slaves by computer");  
    slaves_by_computer->getChild()->setMinimum(1);
    slaves_by_computer->getChild()->setMaximum(16);

	QPushButton *start = new QPushButton("Start");

    QObject::connect(start,SIGNAL(clicked()),this,SLOT(launchSlaves()));

    other_options->addWidget(delay_spinner->getWidget());
    other_options->addWidget(host_address->getWidget());
    other_options->addWidget(time_slave->getWidget());
    other_options->addWidget(slaves_by_computer->getWidget());
    other_options->addWidget(start);
    



    
    
    layout->addLayout(other_options);
    this->setLayout(layout);

}

void SlavesTab::launchSlaves(){
    LoginPopup *popup = new LoginPopup;
    QObject::connect(
        popup,
        SIGNAL(login(QString,QString)),
        this,
        SLOT(launchSlavesWithLogin(QString, QString))
    );
    popup->show();
}

void SlavesTab::launchSlavesWithLogin(QString username, QString password){
    std::cout << "Launching slaves" << std::endl;

    std::stringstream command;
    command << "cd ../src && ( echo '" << username.toUtf8().constData() << "' ; ";
    command << "echo '" << password.toUtf8().constData() << "' ) | ";
    
    command << "./launch_universal.sh ";
    command << host_address->getChild()->text().toUtf8().constData()
        << " "
        << std::to_string(delay_spinner->getChild()->value())
        << " "
        << std::to_string(time_slave->getChild()->value())
        << " "
        << std::to_string(slaves_by_computer->getChild()->value());

    QList<QCheckBox *> cbs = this->findChildren<QCheckBox *>();
    int size = cbs.size();
    for(int i = 0; i<size; i++){
        if(cbs.at(i)->isChecked()){
            command << " " << (cbs.at(i)->text().toUtf8().constData());
        }
    }

    if(system(command.str().c_str())){
        cout << "An error happened when launching the slaves" << endl;
    }
}


