#include <iostream>
#include <ale_interface.hpp>
#include "agent_worker.hpp"
#include "Utils.hpp"
using namespace std;

/**
* @file agent_worker.cpp
* @brief Handle the test of an agent.
*
*/

message::result<double> agent_worker(message::request<agent> request)
{
  ALE.setInt("random_seed", request.seed);
  ActionVect actions = ALE.getLegalActionSet();
  //  const int nb_actions = actions.size();
  message::result<double> res;
  std::vector<unsigned char> screen(210 * 160);
  std::vector<unsigned char> screen42x32(42 * 32);

  //Boucle des evaluations
  for (int episode = 0; episode < request.nb_eval; episode++)
    {
      ALE.reset_game();
      request.params.reset();
      double totalReward = 0;
      int nb = 0;
      while (!ALE.game_over()) { //Boucle de jeu
        ALE.getScreenGrayscale(screen);
        Utils::secam210x160_to_42x32(screen, screen42x32);
        Action a = actions[request.params.get_action(screen42x32)]; //Choix de l'input pour cette frame
        float reward = ALE.act(a);
        totalReward += reward;
        if (++nb > 10000) break; //On arrete de jouer au bout de 10000 tours
      }
      res.results.emplace_back(totalReward);
    }
    return res;
}
