#pragma once
#include "message.hpp"
#include "agent.hpp"

/**
* @file agent_worker.hpp
* @brief Header of agent_worker.cpp
*
*/

/**
* @fn agent_worker(message::request<agent> request) 
* @brief Test the given agent
* @details First of all, the ALE is initialized.
* Then, the agent run until the game-over and that all the evaluation has been done.\n
* In more detail, each frame the screen registers is re-computed and the agent choose and execute an action. Moreover, the reward is calculated and saved for each evaluation.
*
* @param request The agent to be tested.
* @return The results (sum of rewards) acquired by this agent. There are as many results as evaluations.
*/
message::result<double> agent_worker(message::request<agent> request);
