#!/bin/bash

#premier paramètre, la machine hôte
#deuxième paramètre, temps d'attente en heure pour lancer les esclaves
#troisième paramètre, le temps d'exécution de l'esclave en minutes
#quatrième paramètre, nombre d'esclaves par machine (8 est un bon compromis)
#cinquième et plus paramètres, les machines cibles

a=${#BASH_ARGV[@]}
b=5


if [ "$a" -lt "$b" ] ; then
	echo "Warning : Le scrit prend au moins cinq paramètres, votre machine, votre détonation, la durée de la connection, le nbr d'esclaves par machine, et les machines cibles"
	exit
fi

PC1="pc1-info"

PC2="pc2-info"

PC3="pc3-info"

ALLPC="pc1-info
pc2-info
pc3-info"

MACHINES="echiquier
fou
mate
pat
roi
reine
pion
tour
berger
cavalier
volvic
evian
perrier
contrex
vichy
vittel
robinet
badoit
plancoet
yorre
estephe
medoc
sauternes
pomerol
emilion
margaux
graves
blaye
fronsac
julien"
#Toutes les machines hors PC1 PC2 PC3, supprimer si non utilisé

EAUX="volvic
evian
perrier
contrex
vichy
vittel
robinet
badoit
plancoet
yorre"
#Toutes les machines de EAUX, connecté

BORDEAUX="estephe
medoc
sauternes
pomerol
emilion
margaux
graves
blaye
fronsac
julien"
#Toutes les machines de BORDEAUX, connecté

ECHIQUIER="echiquier
fou
mate
pat
roi
reine
pion
tour
berger
cavalier"
#Toutes les machines de ECHIQUIER, connecté

PERSO="plancoet"
#Paramètres personnels

host=$1
time=$3
slave=$4

#Adresse du script
scriptDir=$(dirname -- "$(readlink -f -- "${BASH_SOURCE[0]}")")
#Recuperation des identifiants pour se connecter en ssh
echo -n Username : 
read username
echo -n Password :
read -s password

sleep $2h 

while [ "$5" != "" ]
do
    case $5 in
    pc1)	bool=1;var=$PC1;;
    pc2)	bool=1;var=$PC2;;
    pc3)	bool=1;var=$PC3;;
    allpc)	bool=1;var=$ALLPC;;
    echiquier)	bool=0;var=$ECHIQUIER;;
    eaux)	bool=0;var=$EAUX;;
    bordeaux)	bool=0;var=$BORDEAUX;;
    perso)	bool=0;var=$PERSO;;
    allmac)	bool=0;var=$MACHINES;;
    *)	echo "machines invalides";exit;;
    esac


    #Changer les pgarcia par son login, son mot de passe entre les guillemets et raoh par la machine d'où on lance le maître
    #Sur le LD_LIBRARY_PATH, supprimer le premier ! et remplacer le deuxième par le chemin d'accès où il y a l'exécutable atari
    # par exemple /home-reseau/gsonnet/etudes_pratiques/atari2600/src/atari
    #Commenter les for et les paramètres pour faire tourner les programmes sur des machines spécifiques. TRACE : LD_LIBRARY_PATH=/home-reseau/gsonnet/etudes_pratiques/atari2600/ale/ale

    c=1
    d=0

    if [ "$bool" -eq "$c" ]; then
	   for machine in $var
		  do
    		  for i in `seq 1 10`
    			 do
        		  for j in `seq 1 $slave`
        			 do
            		      	sshpass -p "$password" ssh $username@$machine$i "cd $scriptDir && ./atari --host $host -s --duration $time" &
        			 done
    			 done
		  done
    elif [ "$bool" -eq "$d" ]; then

	   for machine in $var
		  do
   		   for j in `seq 1 $slave`
    		      	do
        		      sshpass -p "$password" ssh $username@$machine "cd $scriptDir && ./atari --host $host -s --duration $time" &
    			     done
		  done
    fi
    shift
done



