#pragma once
#include "master_slave.hpp"
#include "master.hpp"
#include "slave.hpp"
#include "fitness.hpp"
#include <boost/program_options.hpp>
#include <iostream>

/**
* @file master_slave.hpp
* @brief Header of master_slave.cpp
*
*/

/**
* @namespace master_slave
* @brief Handle the start-up of the training algorithm
*
*/
namespace master_slave
{
	/**
	* @fn run
	* @brief Start the algorithm whether in master or slave mode. Also, set parameters used by the algorithm.
	* @details List of parameters set :\n
	* Port used to communicate over the network\n
	* Parameters used to describe the agents\n
	* Parameters used to test the agents\n
	* Parameters used to generate the populations\n
	* Slave duration
	*
	* @param argc Number of launch argument
	* @param argv Array of launch argument
	*/
  void run(int argc, char* argv[]);
}
